//-------------------------------------------------------------------------------
//$Header: /home/dashley/cvsrep/uculib01/uculib01/src/stm8/cosmic/modx0/mfcpuccrgetrxx/unittest/ut_project/stm8/cosmic/modx0/utfu_mfcpuccrgetrxx.c,v 1.2 2010/02/14 18:01:00 dashley Exp $
//-------------------------------------------------------------------------------
//Copyright (c)2010 David T. Ashley
//
//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software source code and associated documentation files (the
//"Software"), to deal in the Software without restriction, including without
//limitation the rights to use, copy, modify, merge, publish, distribute,
//sublicense, and/or sell copies of the Software, and to permit persons to whom
//the Software is furnished to do so, subject to the following conditions:
//
//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
//-------------------------------------------------------------------------------
#define MODULE_UTFU_MFCPUCCRGETRXX

#include "\uculib01\include\stm8\cosmic\c\uculib.h"
#include "utfu_mfcpuccrgetrxx.h"


//Returns the number of test vectors that may be used for a speed test.
//
UCU_UINT32 UtsnMfCpuCcrGetRxx(void)
   {
   return(1);  //There is only one test vector.
   }


//Runs a selected test vector.  This is used for automated speed testing.
//
void UtspMfCpuCcrGetRxx(UCU_UINT32 test_no, void (*start_pointer)(void), void (*end_pointer)(void))
   {
   UCU_CPU_CCR rv;

   //We are ready to make the call.  Start the caller's timer.
   (*start_pointer)();

   //Call the function.
   rv = UcuMfCpuCcrGetRxx();

   //The call is finished.  Stop the caller's timer.
   (*end_pointer)();
   }


//Runs all test vectors.  Returns TRUE if OK, FALSE if any failed.
//
UCU_BOOLEAN UtfuMfCpuCcrGetRxx(void)
   {
   UCU_CPU_CCR rv;
   UCU_UINT32  rv_long;

   rv      = UcuMfCpuCcrGetRxx();

   rv_long = UcuMfCpuCcrGetRxx();

   //Do some dumb stuff to make sure the compiler actually saves the values returned
   //above.  Without some use of the variables, the compiler may simply discard
   //the return values, which makes it hard to use a debugger to double-check
   //the behaviors.  Because the compiler can't verify that the function calls below
   //don't have side effects, these should be effective.
   UcuBtU32BitCardRxx(rv);
   UcuBtU32BitCardRxx(rv_long);

   return(UCU_TRUE);  //No way to really test the return value except with a debugger.
                      //It could legally be just about anything.
   }


//-------------------------------------------------------------------------------
//$Log: utfu_mfcpuccrgetrxx.c,v $
//Revision 1.2  2010/02/14 18:01:00  dashley
//Unit test completed.
//
//Revision 1.1  2010/02/14 17:52:38  dashley
//Initial checkin.
//-------------------------------------------------------------------------------
//End of $RCSfile: utfu_mfcpuccrgetrxx.c,v $
//-------------------------------------------------------------------------------

